/*
 * Copyright (c) 2018, ARM Limited and Contributors. All rights reserved.
 *
 * SPDX-License-Identifier: BSD-3-Clause
 */

#include MBEDTLS_CONFIG_FILE

	.global mtk_rotpk_hash
	.global mtk_rotpk_hash_end
	.section .rodata.mtk_rotpk_hash, "a"
mtk_rotpk_hash:
	/* DER header */
#if TF_MBEDTLS_HASH_ALG_ID == TF_MBEDTLS_SHA512
	.byte 0x30, 0x51, 0x30, 0x0D, 0x06, 0x09, 0x60, 0x86, 0x48
	.byte 0x01, 0x65, 0x03, 0x04, 0x02, 0x03, 0x05, 0x00, 0x04, 0x40
	/* SHA512 */
#elif TF_MBEDTLS_HASH_ALG_ID == TF_MBEDTLS_SHA384
	.byte 0x30, 0x41, 0x30, 0x0D, 0x06, 0x09, 0x60, 0x86, 0x48
	.byte 0x01, 0x65, 0x03, 0x04, 0x02, 0x02, 0x05, 0x00, 0x04, 0x30
	/* SHA384 */
#else
	.byte 0x30, 0x31, 0x30, 0x0D, 0x06, 0x09, 0x60, 0x86, 0x48
	.byte 0x01, 0x65, 0x03, 0x04, 0x02, 0x01, 0x05, 0x00, 0x04, 0x20
	/* SHA256 */
#endif
	.incbin ROTPK_HASH
mtk_rotpk_hash_end:
